//*********************************************************
//
// stringfr.h
//
// Copyright(c) 1999-2000, Yuganda Tsuki
//
//*********************************************************
/*
 * $Log: stringfr.h,v $
 * Revision 1.2  2001/01/20 07:40:17  syou
 * - Í̍ہAToACcABcc̃AhXDefault RecipientƂĈ悤ɂA
 *   ܂Cӂ̌JgĈÍł悤ɂB܂ADefault Recipient
 *   Default Private Key̒ǉ\ɂIvV݂BA
 *   ͂Ȃr(^^;
 *
 * Revision 1.1  2000/11/07 15:57:20  syou
 * - PGPsdkpX[h͎ɍsĂZLeBtbNɂ镛pŁA
 *   MFCpWindow쐬Becky!AT[g邱Ƃh߂ɁAPGPB2
 *   }`XbhBāAversion 0.00.1̌ĂƂ
 *   ܂B
 *   [STLx[X̓ƎNXɕύXBsx̑̌ړI
 *   ƂāAVC++tSTLł͂ȂASTLport-4.0̗pB
 *   CO[Ů҂ɉ邽߁Aeo̓bZ[W\[Xɓ{ŏ
 *   ł̂AXɃ\[Xֈڂ͂߂Ă܂B
 *   PGP/MIMEbZ[W̌؂ƕɑΉ悤Ǝ݂iڂ͓
 *   vO\[XQƁjA،ʂ̕\@ɗǂ@v΂ȂB
 *   ACfAR[h΂肢܂B
 *
 */

#pragma once


///////////////////////////////////////////////////////////////////////////
//
#include <winuser.h>
#include <string>
#include "B2API.h"


///////////////////////////////////////////////////////////////////////////
//
using namespace std;


///////////////////////////////////////////////////////////////////////////
//

template< class E, class Tr = char_traits<E>, class A = allocator<E> >
class basic_stringfr : public basic_string<E, Tr, A>
{
public:
    explicit basic_stringfr(HINSTANCE initInstance, DWORD id = 0);
	//~basic_stringfr();
    basic_stringfr<E, Tr, A>& getsfr(DWORD id);
    basic_stringfr<E, Tr, A>& utf8();
private:
    HINSTANCE instance;
    B2API* B2;
};


template< class E, class Tr, class A > inline
    basic_stringfr<E, Tr, A>::basic_stringfr(HINSTANCE initInstance, DWORD id)
    : basic_string<E, Tr, A>()
{
	instance = initInstance;
    B2 = B2API::Instance();
    if (id) {
		getsfr(id);
	}
}


template< class E, class Tr, class A > inline
    basic_stringfr<E, Tr, A>& basic_stringfr<E, Tr, A>::getsfr(DWORD id)
{
	int len = 0;
    int size = 0;
    E* str = NULL;
    while (size - len <= sizeof(E)) {
		E* old_str = str;
        size += 256*sizeof(E);
        str = reinterpret_cast<E*>(realloc(str, size));
        if (str == NULL) {
			if (old_str) {
				free(old_str);
			}
            return *this;
		}
        len = ::LoadString(instance, id, str, size);
	}
    assign(str);
    free(str);
    return *this;
}

template< class E, class Tr, class A > inline
    basic_stringfr<E, Tr, A>& basic_stringfr<E, Tr, A>::utf8()
{
	E* out = NULL;
    out = B2->UTF_8(c_str(), TRUE);
    if (out) {
        assign(out);
        B2->Free(out);
	}
    return *this;
}


template< class E, class Tr, class A > inline
basic_string<E, Tr, A> toUtf8(const basic_string<E, Tr, A>& str)
{
    B2API* B2 = B2API::Instance();
	E* out = NULL;
    string result;
    out = B2->UTF_8(str.c_str(), TRUE);
    if (out) {
        result.assign(out);
        B2->Free(out);
	}
    return result;
}


#ifdef UNICODE
typedef basic_stringfr<wchar_t> stringfr;
#else
typedef basic_stringfr<char> stringfr;
#endif

