/////////////////////////////////////////////////////////////////////////////////
//
// DecryptListener.h
//
// Copyright (C) 2000 YUGA. All rights reserved.
//
/*
 * $Log: DecryptListener.h,v $
 * Revision 1.3  2000/11/07 15:57:17  syou
 * - PGPsdkpX[h͎ɍsĂZLeBtbNɂ镛pŁA
 *   MFCpWindow쐬Becky!AT[g邱Ƃh߂ɁAPGPB2
 *   }`XbhBāAversion 0.00.1̌ĂƂ
 *   ܂B
 *   [STLx[X̓ƎNXɕύXBsx̑̌ړI
 *   ƂāAVC++tSTLł͂ȂASTLport-4.0̗pB
 *   CO[Ů҂ɉ邽߁Aeo̓bZ[W\[Xɓ{ŏ
 *   ł̂AXɃ\[Xֈڂ͂߂Ă܂B
 *   PGP/MIMEbZ[W̌؂ƕɑΉ悤Ǝ݂iڂ͓
 *   vO\[XQƁjA،ʂ̕\@ɗǂ@v΂ȂB
 *   ACfAR[h΂肢܂B
 *
 * Revision 1.2  2000/07/15 02:09:55  syou
 * - PGP/MIMEÍƏꂽ[̏؂Bclass
 *   CDecryptListenerclass CSignatureListenerhAPGP/MIME
 *   ꂽ[̏؂ƁA\[`LBƂ
 *   CɂȂ̂͂2̃NX̖OAPGPEventtׂH
 *
 * Revision 1.1  2000/07/13 15:12:24  syou
 * - PGP/MIME`̈Í[̕B
 *   PGPEventHandlerAeListenerƂɎ悤ɂBclass CEventListener
 *   hIuWFNgEventHandlerꂼĎgB
 *   SignatureData.h폜AEventListener.hAEventListener.cppASignatureListener.h
 *   SignatureListener.cppADecryptListener.hADecryptListener.cppǉB
 *   count_ptr<CBkMailPart*>CBkMailPartPtrtypedefB
 *   \[XSʂɓnāAfree(memoryblock*)̑OmemoryblockNULLłȂ
 *   `FbNĂ̂AMSDNCu[̃QW[t@XQƂɍ폜B
 *
 */


#pragma once


/////////////////////////////////////////////////////////////////////////////////
//
#include "SignatureListener.h"
#include "PassphraseMgr.h"


/////////////////////////////////////////////////////////////////////////////////
//
class DecryptListener : public SignatureListener
{
public:
    DecryptListener(HWND hWnd, PassphraseMgr& pmgr);
    virtual ~DecryptListener();
    virtual PGPError listenEvent(PGPContextRef context, PGPEvent* event);
    virtual void setWindowHandle(HWND newHWnd);
    virtual HWND getWindowHandle() const;

protected:
    virtual PGPError inputPassphrase(PGPContextRef context, PGPEvent* event);
    virtual bool getPassphraseFromDecryptCache(PGPKeySetRef keyset, PGPKeyRef& key, char*& passphrase);

private:
    HWND hWnd;
    PassphraseMgr& cache;
};


/////////////////////////////////////////////////////////////////////////////////
//
