////////////////////////////////////////////////////////////////////////////////////
//
// Pgpb2Utility.cpp
//
// Copyright (C) 2000 YUGA. All rights reserved.
//
/*
 * $Log: Pgpb2Utility.cpp,v $
 * Revision 1.4  2001/01/20 07:40:17  syou
 * - Í̍ہAToACcABcc̃AhXDefault RecipientƂĈ悤ɂA
 *   ܂Cӂ̌JgĈÍł悤ɂB܂ADefault Recipient
 *   Default Private Key̒ǉ\ɂIvV݂BA
 *   ͂Ȃr(^^;
 *
 * Revision 1.3  2000/11/29 12:46:35  syou
 * - broken version line ̏CBsɂ܂Ă͖̂炩Ƀ~X
 *   łB
 *
 * Revision 1.2  2000/11/07 15:57:20  syou
 * - PGPsdkpX[h͎ɍsĂZLeBtbNɂ镛pŁA
 *   MFCpWindow쐬Becky!AT[g邱Ƃh߂ɁAPGPB2
 *   }`XbhBāAversion 0.00.1̌ĂƂ
 *   ܂B
 *   [STLx[X̓ƎNXɕύXBsx̑̌ړI
 *   ƂāAVC++tSTLł͂ȂASTLport-4.0̗pB
 *   CO[Ů҂ɉ邽߁Aeo̓bZ[W\[Xɓ{ŏ
 *   ł̂AXɃ\[Xֈڂ͂߂Ă܂B
 *   PGP/MIMEbZ[W̌؂ƕɑΉ悤Ǝ݂iڂ͓
 *   vO\[XQƁjA،ʂ̕\@ɗǂ@v΂ȂB
 *   ACfAR[h΂肢܂B
 *
 * Revision 1.1  2000/08/06 15:14:42  syou
 * - message/rfc822`Ń[YtĂꍇAYtĂ郁[
 *   ǂ̑ΏۂƂȂ悤ɂBB2(beta23)ȍ~ep[g Content-Typew
 *   ƎQƂ邱ƂmFBAbeta22ȑOgč쐬ꂽ
 *   multipart[̏ꍇ́Â肭Ȃ悤ɎvB
 *   main.cpp剻߁ABclass CPgpb2ǉA
 *   Pgpb2Decode.cppAPgpb2Encode.cppAPgpb2Utility.cppɕčsB
 *   剻ABkMail.h𕪊Bclass`BkMessage.hɏWA
 *   class CBkMessagẽCC֐BkMessage.hɁAclass CBkMailPart̃C
 *   C֐BkMailPart.hɁAclass CBkMail̃CC֐BkMail.hɋL
 *   qA#includeɂABkMessage.h̖Ɏ荞łB
 *   ȊÓAꂼBkMessage.cppABkMailPart.cppABkMail.cppɎB
 *   message/rfc822`̓Yt[ɑΉ邽߁A class CBkRfc822ǉBC
 *   C֐ BkRfc822.hɋLqȂBkRfc822.cppɎBclass
 *   CBkMessage̔hNXÂNXłclass
 *   CBkMessageɈϏB
 *   Encodẽ[`̕ADecodê̂ɓB܂A
 *         CBkMailPartPtr apEncrypt1;
 *         apEncrypt1 = mail.SetChild(new CMIMEItem());
 *
 */


////////////////////////////////////////////////////////////////////////
//
#include "Pgpb2.h"
#include <mbstring.h>


////////////////////////////////////////////////////////////////////////
// Constructer
Pgpb2::Pgpb2(HINSTANCE initInstance)
{
    HookStart(initInstance);
    mes = new stringfr(initInstance);
}


Pgpb2::~Pgpb2()
{
    HookEnd();

    delete mes;
    delete cache;

    if(PGPContextRefIsValid(context)) {
        PGPFreeContext(context);
        context = NULL;
    }
}


void Pgpb2::init()
{
    // B2API+擾
    b2api = B2API::Instance();
    b2apiex = B2APIEx::InstanceEx();

    // PGP̃Xbh𐶐
    context = kInvalidPGPContextRef;
    PGPError pgpError = PGPNewContext(kPGPsdkAPIVersion, &context);
    PGPCheckSdkError(pgpError, "The error occured in NewContext.");

    // pXt[Ÿꎞۑ@\𐶐
    cache = new PassphraseMgr(context, config);

    // PGPIWił邢cktł̋ʂ擾
    HKEY regKey;
    LONG regError = ::RegOpenKeyEx(HKEY_LOCAL_MACHINE,"SOFTWARE\\Network Associates\\PGP", 0, KEY_READ, &regKey);
    if (regError == ERROR_SUCCESS) {
        DWORD type;
        DWORD bufferSize = 0;
        ::RegQueryValueEx(regKey, "Version", NULL, &type, NULL, &bufferSize);
        char* version = new char[bufferSize];
        regError = ::RegQueryValueEx(regKey, "Version", NULL, &type, reinterpret_cast<unsigned char*>(version), &bufferSize);
        if (regError == ERROR_SUCCESS) {
            pgpversion = version;
        }
        delete [] version;
        ::RegCloseKey(regKey);
    }

    // PGP/MIMEftHgŃI
    pgpmime = true;
}


////////////////////////////////////////////////////////////////////////
//
/**
 * PGP/MIME̔
 */
bool Pgpb2::isPgpmime()
{
     return pgpmime;
}


/**
 * ꎞۑĂpXt[Y̏
 */
bool Pgpb2::clearPassphraseCache()
{
    cache->clearSignPassphrase();
    cache->clearDecryptPassphrase();

    return true;
}


////////////////////////////////////////////////////////////////////////
// Utility
int Pgpb2::addAddressList(CPointerList& plstAddr, const string& toccbcc)
{
    char szName[256]; // oOi֐spj
    char szEMail[256]; // o[AhX
    char szUserID[260]; // [UID
    int size = 0;
    LPSTR lpTok; // ؂oACe
    LPSTR lpToCcBcc = b2api->SerializeRcpts(toccbcc.c_str());
    lpTok = TokenAddr(lpToCcBcc);
    while (lpTok) {
        GetNameAndAddr(szName, 256, szEMail, 256, lpTok);
        sprintf(szUserID, "%s", szEMail);
        plstAddr.AddTail(szUserID);
        size += strlen(szUserID) + 2; // u[UID̒+2vZ
        lpTok = TokenAddr(NULL);
    }
    b2api->Free(lpToCcBcc);
    return size;
}


void Pgpb2::getKeySet(CPointerItem* pItem, PGPKeySetRef& defaultKeySet, PGPKeySetRef& foundUserKeySet)
{
    PGPFilterRef filter = kInvalidPGPFilterRef;
    PGPFilterRef newFilter = kInvalidPGPFilterRef;
    PGPFilterRef oldFilter = kInvalidPGPFilterRef;

    try {

        PGPError err = kPGPError_NoErr;

        while (pItem) {
            LPSTR lpStr = pItem->GetData();
            if (filter == NULL) {
                err = PGPNewUserIDEmailFilter(context, lpStr, kPGPMatchEqual, &filter);
                PGPCheckSdkError(err, "The error occured in NewUserIDEmailFilter.");
            }
            else {
                err = PGPNewUserIDEmailFilter(context, lpStr, kPGPMatchEqual, &newFilter);
                PGPCheckSdkError(err, "The error occured in NewUserIDEmailFilter.");

                err = PGPUnionFilters(oldFilter, newFilter, &filter);
                PGPCheckSdkError(err, "The error occured in PGPUnionFilters.");
            }
            oldFilter = filter;
            pItem = pItem->GetNext();
        }

        err = PGPFilterKeySet(defaultKeySet, filter, &foundUserKeySet);
        PGPCheckSdkError(err, "The error occured in FilterKeySet.");

    } catch (PGPSdkError) {
        // Clean up
        if(PGPFilterRefIsValid(filter)) {
            PGPFreeFilter(filter);
        }
        if(PGPFilterRefIsValid(newFilter)) {
            PGPFreeFilter(newFilter);
        }

        throw;
    }

    // Clean up
    if(PGPFilterRefIsValid(filter)) {
        PGPFreeFilter(filter);
    }
}


int Pgpb2::getDefaultRecipients(PGPKeySetRef keySet, PGPRecipientSpec*& outSpec)
{
    // result
    int index = 0;

    PGPKeyListRef keyList = NULL;
    PGPKeyIterRef keyIter = NULL;

    try {

        PGPUInt32 count = 0;
        PGPError err = PGPCountKeys(keySet, &count);
        PGPCheckSdkError(err, "The error occured in CountKeys.");

        err = PGPOrderKeySet(keySet, kPGPAnyOrdering, &keyList);
        PGPCheckSdkError(err, "The error occured in OrderKeySet.");

        err = PGPNewKeyIter(keyList, &keyIter);
        PGPCheckSdkError(err, "The error occured in NewKeyIter.");

        outSpec = new PGPRecipientSpec[count+1];
        if (outSpec == NULL) {
            throw PGPSdkError(err, "The error occured in RecipientSpec.");
        }

        PGPRecipientSpec spec;
        ::ZeroMemory(&spec, sizeof(PGPRecipientSpec));
        spec.type = kPGPRecipientSpecType_Key;
        spec.locked = FALSE;

        PGPKeyRef key = NULL;
        err = PGPKeyIterNext(keyIter, &key);

        for (index = 0; (unsigned) index < count; index++) {
            PGPCheckSdkError(err, "The error occured in KeyIterNext.");
            spec.u.key = key;
            memcpy(&outSpec[index], &spec, sizeof(PGPRecipientSpec));
            err = PGPKeyIterNext(keyIter, &key);
        }

        if (config.isEncryptDefaultKey()) {
            err = PGPGetDefaultPrivateKey(keySet, &key);
            if (IsntPGPError(err)) {
                spec.u.key = key;
                memcpy(&outSpec[index], &spec, sizeof(PGPRecipientSpec));
                index++;
            }
        }

    } catch (PGPSdkError) {
        // Clean up
        if (PGPKeyIterRefIsValid(keyIter)) {
            PGPFreeKeyIter(keyIter);
        }
        if (PGPKeyListRefIsValid(keyList)) {
            PGPFreeKeyList(keyList);
        }

        throw;
    }

    // Clean up
    PGPFreeKeyIter(keyIter);
    PGPFreeKeyList(keyList);

    return index;
}


void Pgpb2::getKeyRef(PGPKeySetRef keySet, PGPKeyRef& key, int index)
{
    PGPKeyListRef keyList = NULL;
    PGPKeyIterRef keyIter = NULL;

    try {

        PGPError err = PGPOrderKeySet(keySet, kPGPAnyOrdering, &keyList);
        PGPCheckSdkError(err, "The error occured in OrderKeySet.");

        err = PGPNewKeyIter(keyList, &keyIter);
        PGPCheckSdkError(err, "The error occured in NewKeyIter.");

        for (int count = 0; count <= index; count++) {
            err = PGPKeyIterNext(keyIter, &key);
            PGPCheckSdkError(err, "The error occured in NewKeyIter.");
        }

    } catch (PGPSdkError) {
        // Clean up
        if (PGPKeyIterRefIsValid(keyIter)) {
            PGPFreeKeyIter(keyIter);
        }
        if (PGPKeyListRefIsValid(keyList)) {
            PGPFreeKeyList(keyList);
        }

        throw;
    }

    // Clean up
    PGPFreeKeyIter(keyIter);
    PGPFreeKeyList(keyList);
}


bool Pgpb2::getHashAlgorithm(PGPKeyRef& signingKey, LPSTR lpHash)
{
    if (lpHash == NULL) {
        return false;
    }

    PGPHashAlgorithm hashAlg;
    PGPError err = PGPGetHashAlgUsed(signingKey, &hashAlg);
    if (IsPGPError(err)) {
        return false;
    }

    switch (hashAlg) {
    case kPGPHashAlgorithm_Invalid://0
        return FALSE;
    case kPGPHashAlgorithm_MD5://1
        strcpy(lpHash, "md5");
        break;
    case kPGPHashAlgorithm_SHA://2
        strcpy(lpHash, "sha1");
        break;
    case kPGPHashAlgorithm_RIPEMD160://3
        strcpy(lpHash, "ripemd160");
        break;
    //BEGIN SHA DOUBLE MOD - Imad R. Faiad
    case kPGPHashAlgorithm_SHADouble://4
        strcpy(lpHash, "sha1x");
        break;
    //END SHA DOUBLE MOD - Imad R. Faiad
    //BEGIN MD2 MOD - private
    case 5/*kPGPHashAlgorithm_MD2*/://5
        strcpy(lpHash, "md2");
        break;
    //END MD2 MOD - private
    //BEGIN TIGER192 MOD - Imad R. Faiad
    case kPGPHashAlgorithm_TIGER192://6
        strcpy(lpHash, "tiger192");
        break;
    //END TIGER192 MOD - Imad R. Faiad
    //BEGIN SHA2 MOD - Disastry
    case kPGPHashAlgorithm_SHA256://8
        strcpy(lpHash, "sha256");
        break;
    case kPGPHashAlgorithm_SHA384://9
        strcpy(lpHash, "sha384");
        break;
    case kPGPHashAlgorithm_SHA512://10
        strcpy(lpHash, "sha512");
        break;
    //END SHA2 MOD - Disastry
    default:
        return false;
    }

    return true;
}


void Pgpb2::appendConventionalEncryptionOptionList(HWND hWnd, PGPOptionListRef optionList)
{
    char *lpPassphrase = NULL;
    PGPError err = PGPConventionalEncryptionPassphraseDialog(
                    context,
                    PGPOUIParentWindowHandle(context, hWnd),
                    PGPOUIOutputPassphrase(context, &lpPassphrase),
                    PGPOLastOption(context)
                    );

    PGPCheckUserAbort(err, "User Canceled.");
    PGPCheckSdkError(err, "The error occured in PGPConventionalEncryptionPassphraseDialog.");

    err = PGPAppendOptionList(
            optionList,
            PGPOConventionalEncrypt(context,
                PGPOPassphrase(context,lpPassphrase),
                PGPOLastOption(context)
                ),
            PGPOLastOption(context)
            );

    PGPCheckSdkError(err, "The error occured in PGPAppendOptionList.");
    PGPFreeData(lpPassphrase);
 }


void Pgpb2::appendEncryptionOptionList(PGPKeySetRef keySet, PGPOptionListRef optionList)
{
    PGPUInt32 count;
    PGPError err = PGPCountKeys(keySet, &count);
    PGPCheckSdkError(err, "The error occured in PGPCountKeys.");
    if ( count < 1) {
        throw PGPUserError("User didn't select any Recipients.");
    }

    err = PGPAppendOptionList(
            optionList,
            PGPOEncryptToKeySet(context, keySet),
            PGPOLastOption(context)
            );

    PGPCheckSdkError(err, "The error occured in PGPAppendOptionList.");
}


string Pgpb2::getExportKeySetFileName(PGPKeySetRef keySet)
{
    std::string filename("Exported PGP Key(s).asc");

    PGPUInt32 count = 0;
    PGPError err = PGPCountKeys(keySet, &count);
    if (IsPGPError(err) || count == 0 || count > 1) {
        return filename;
    }

    PGPKeyListRef keyList = NULL;
    err = PGPOrderKeySet(keySet, kPGPAnyOrdering, &keyList);
    if (IsPGPError(err)) {
        return filename;
    }

    PGPKeyIterRef keyIter = NULL;
    err = PGPNewKeyIter(keyList, &keyIter);
    if (IsPGPError(err)) {
        PGPFreeKeyList(keyList);
        return filename;
    }

    PGPKeyRef key = NULL;
    err = PGPKeyIterNext(keyIter, &key);
    if (IsPGPError(err)) {
        PGPFreeKeyIter(keyIter);
        PGPFreeKeyList(keyList);
        return filename;
    }

    LPSTR idName = NULL;
    PGPSize idNamelen = 0;
    PGPGetPrimaryUserIDNameBuffer(key, idNamelen, idName, &idNamelen);
    idName = new char[idNamelen+1];
    PGPGetPrimaryUserIDNameBuffer(key, idNamelen, idName, &idNamelen);

    PGPFreeKeyIter(keyIter);
    PGPFreeKeyList(keyList);

    if (IsPGPError(err)) {
        return filename;
    }

    char* name;
    unsigned char* addr = _mbschr(reinterpret_cast<unsigned char*>(idName), '<');
    if (addr++ && addr != '\0') {
        name = reinterpret_cast<char*>(addr);
        unsigned char* npos = _mbschr(reinterpret_cast<unsigned char*>(addr), '>');
        *npos = '\0';
    } else {
        name = idName;
    }

    char legalName[_MAX_PATH];
    ::GetLegalFileName(name, legalName, _MAX_PATH);
    delete [] idName;

    filename.assign(legalName);
    filename.append(".asc");

    return filename;
}


bool Pgpb2::getPassphraseFromSignCache(PGPKeySetRef keySet, PGPKeyRef& key, char*& passphrase)
{
    PGPUInt32 count = 0;
    PGPError err = PGPCountKeys(keySet, &count);
    if (IsPGPError(err)) {
        return false;
    }

    PGPKeyListRef keyList = NULL;
    err = PGPOrderKeySet(keySet, kPGPKeyIDOrdering, &keyList);
    if (IsPGPError(err)) {
        return false;
    }

    PGPKeyIterRef keyIter = NULL;
    err = PGPNewKeyIter(keyList, &keyIter);
    if (IsPGPError(err)) {
        return false;
    }

    err = PGPKeyIterNext(keyIter, &key);

    int index;
    for (index = 0; IsntPGPError(err) && (unsigned) index < count; index++) {
        passphrase = cache->getSignPassphrase(key);
        if (passphrase) {
            return true;
        }
        err = PGPKeyIterNext(keyIter, &key);
    }

    return false;
}


void Pgpb2::SigTimeToSystemTime(struct tm* ptm, SYSTEMTIME* pst)
{
    pst->wYear = ptm->tm_year + 1900;
    pst->wMonth = ptm->tm_mon + 1;
    pst->wDay = ptm->tm_mday;
    pst->wDayOfWeek = ptm->tm_wday;
    pst->wHour = ptm->tm_hour;
    pst->wMinute = ptm->tm_min;
    pst->wSecond = ptm->tm_sec;
    pst->wMilliseconds = 0;
}


void Pgpb2::ConvertSigTimeToString(PGPTime Time, LPSTR sz, INT iLen)
{
    SYSTEMTIME    systemtime;
    time_t        ttTime;
    struct tm*    ptm;

    ttTime = PGPGetStdTimeFromPGPTime (Time);
    ptm = localtime (&ttTime);

    SigTimeToSystemTime (ptm, &systemtime);
    GetDateFormat(LOCALE_USER_DEFAULT, DATE_SHORTDATE, &systemtime,
        NULL, sz, iLen);
    strcat(sz," ");
    GetTimeFormat(LOCALE_USER_DEFAULT, LOCALE_NOUSEROVERRIDE, &systemtime,
        NULL, &(sz[strlen(sz)]),iLen-strlen(sz));
}


void Pgpb2::SEGetPref64BitsKeyIDDisplay(PGPUInt32 *H64BitsKeyIDDisplay)
{
    HKEY  hKey;
    LONG  lResult;
    DWORD dw;
    char    path[] = "Software\\Network Associates\\PGP\\Pref64BitsKeyIDDisplay";

    lResult = ::RegOpenKeyEx(HKEY_CURRENT_USER, path, 0, KEY_ALL_ACCESS, &hKey);

    if (lResult == ERROR_SUCCESS) {
        DWORD  size = sizeof(dw);
        DWORD  type = 0;

        ::RegQueryValueEx(hKey, "64BitsKeyIDDisplay", 0, &type, reinterpret_cast<LPBYTE>(&dw), &size);
        if ((dw < 0) || (dw > 1)) {
            dw = 1;
        }
        ::RegCloseKey(hKey);

    } else {// Init Values

        lResult = ::RegCreateKeyEx(HKEY_CURRENT_USER, path, 0, NULL,
                                    REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS,
                                    NULL, &hKey, &dw);
        if (lResult == ERROR_SUCCESS) {
            dw = 0;
            ::RegSetValueEx (hKey, "64BitsKeyIDDisplay", 0, REG_DWORD,
                                reinterpret_cast<LPBYTE>(&dw), sizeof(dw));
            ::RegCloseKey(hKey);
        }
    }

    *H64BitsKeyIDDisplay = (PGPUInt32) dw;
}


BOOL Pgpb2::SEGetKeyIDString(PGPKeyID KeyID, LPSTR sz, UINT u)
{

    CHAR szID[kPGPMaxKeyIDStringSize];
    UINT uDisplay;
    PGPKeyIDStringType abbrev;
    if (u < 19) {
        return FALSE;
    }

    SEGetPref64BitsKeyIDDisplay(&uDisplay);

    if (uDisplay == 1) {
        abbrev = kPGPKeyIDString_Full;
    } else {
        abbrev = kPGPKeyIDString_Abbreviated;
    }

    PGPGetKeyIDString (&KeyID, abbrev, szID);
    lstrcpy (sz, "0x");
    lstrcat (sz, &szID[2]);

    return TRUE;
}


/*std::string Pgpb2::showKeyFingerprint(PGPKeyRef key)
{
    PGPError err;
    PGPSize actual;
    char h1[30], h2[30], h3[15];
    unsigned char fp[20];

    err = PGPGetKeyPropertyBuffer (key, kPGPKeyPropFingerprint, 20, &fp, &actual);
    if (IsPGPError(err)) {
        throw PGPSdkError(err, "The error occured in PGPGetKeyPropertyBuffer.");
    }
    sprintf( h1, "  %02x %02x %02x %02x %02x %02x %02x %02x",
            fp[0],fp[1],fp[2],fp[3],fp[4],fp[5],fp[6],fp[7] );
    strupr( h1 );
    sprintf( h2, "  %02x %02x %02x %02x %02x %02x %02x %02x",
            fp[8],fp[9],fp[10],fp[11],fp[12],fp[13],fp[14],fp[15]);
    strupr( h2 );
    if(actual > 16) {
        sprintf( h3, "  %02x %02x %02x %02x",fp[16],fp[17],fp[18],fp[19] );
        strupr( h3 );
    } else
        h3[0] = '\0';

    stringstream out;
    out << "Key fingerprint: " << h1 << h2 << h3 << "\r\n";
    return err;
}*/


////////////////////////////////////////////////////////////////////////
// PGPSdkError
#ifdef PGPSdkError
#undef PGPSdkError
#endif


PGPSdkError::PGPSdkError(PGPError initError, const std::string& message,
    const std::string& initFile, int initLine) throw()
    : error(initError), runtime_error(message), file(initFile), line(initLine) {}

std::string PGPSdkError::getPGPErrorMessage() const throw()
{
    PGPSize bufferSize = 0;
    char* message = NULL;
    PGPError err = 0;

    do {
        bufferSize += 1024;
        message = reinterpret_cast<char*>(realloc(message, bufferSize));
        err = PGPGetErrorString(error, bufferSize, message);
    } while (err == kPGPError_BufferTooSmall && bufferSize < 1024*10);

    std::string out(message);
    free(message);

    return out;
}


#include <sstream>

std::string PGPSdkError::getErrorSpecification() const throw()
{
    std::stringstream message;
    message << what() << "\r\n\r\nFile: " << getFile() << "\r\nLine: " << getLine() << "\r\n\r\n"
            << getPGPErrorMessage();
    return message.str();
}


////////////////////////////////////////////////////////////////////////
//

